/*=============================================================================
#  Author:          DanteZhu - http://www.vimer.cn
#  Email:           dantezhu@vip.qq.com
#  FileName:        db_openright.h
#  Description:     
#  Version:         1.0
#  LastChange:      2010-10-11 17:13:25
#  History:         
=============================================================================*/
#ifndef _DB_OPENRIGHT_H_
#define _DB_OPENRIGHT_H_

#include <string>
#include <set>
using namespace std;

#include "mysql_cpp_client.h"

#define MAX_ERRMSG_OPENRIGHT 512
#define MAX_QUERYLEN_OPENRIGHT  40960

#define OPENRIGHT_DB            "openright"

#define OPENRIGHT_TB_CARE       "dev_attention"
#define OPENRIGHT_TB_PASSWD     "dev_passwd"

#define TPL_ADDUIN2APP          "(%u,%u)"

class CDBOpenRight
{
    public:
        CDBOpenRight();
        ~CDBOpenRight();
        int Init(const char* ip,const char* user,const char* pwd);

        char* GetErrMsg();

        int GetUinsByApp(unsigned appid,set<unsigned>& setUins);
        int AddUin2App(unsigned appid,const set<unsigned>& setUins);

    private:
        char m_StrErrMsg[MAX_ERRMSG_OPENRIGHT];
        string m_MySql_Ip;
        string m_MySql_User;
        string m_MySql_Pwd;

        CMySQLCppClient m_SqlClient;
};
#endif
