/*=============================================================================
#  Author:          DanteZhu - http://www.vimer.cn
#  Email:           dantezhu@vip.qq.com
#  FileName:        mysql_cpp_client.h
#  Version:         1.0
#  LastChange:      2010-02-25 11:10:20
#  Description:     MYSQL CPP Client
#  History:         
=============================================================================*/
#ifndef _MYSQL_CPP_CLIENT_H_
#define _MYSQL_CPP_CLIENT_H_
#include <iostream>
#include <pthread.h>
#include <asm/atomic.h>
#include <string>
#include <vector>
#include <sys/time.h>
#include <asm/atomic.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <sys/time.h>
#include <stdio.h>
#include <math.h>
#include <iostream>
#include "mysql.h"
//=============================================================================
using namespace std;
//=============================================================================
#define MAX_ERRMSG_MYSQL   512
//=============================================================================
//ͳһ󷵻
typedef enum {/*{{{*/
    /* ɹ */
    CppSQLSucceed = 0, 

    /* ϵͳ */
    CppSQLErrSystem = -1000,        //Ƿ
    CppSQLErrSystemMemory,          //ڴʧ
    CppSQLErrSystemPointer,         //ָ
    CppSQLErrSystemNoMem,           //ռ䲻

    /*DB*/
    CppSQLErrDBInit = -2000,        //DBʼʧ
    CppSQLErrDBConn,                //DBʧ
    CppSQLErrDBExe,                 //DBִʧ
    CppSQLErrDBRes,                 //DBResultΪ
    CppSQLErrDBEmpty,               //ݲ 
} CppSQLRetcode;/*}}}*/
//=============================================================================
typedef struct _st_cppresult
{
    public:
        _st_cppresult(MYSQL_RES* result)
        {
            m_result = result;
        }
        ~_st_cppresult()
        {
            if(NULL != m_result)
            {
                mysql_free_result(m_result);
            }
        }

    private:
        MYSQL_RES *m_result;
}StCppResult;
//=============================================================================
class CMySQLCppClient
{/*{{{*/
    public:
        CMySQLCppClient();
        ~CMySQLCppClient();
        int Connect(const char* ip,const char* user,const char* pwd,const char* strDb);
        int Execute(const char* strSql);
        int Result(MYSQL_RES *&result);
        int AffectRows();

        string EscapeRealString(const char* src,unsigned int len);

        void Close();
        char* GetErrMsg();
    protected:
        void _CloseMySQL();
    private:
        char m_StrErrMsg[MAX_ERRMSG_MYSQL];

        string m_MySql_Ip;
        string m_MySql_User;
        string m_MySql_Pwd;
        string m_MySql_Db;

        MYSQL*      m_Database;
};/*}}}*/
//=============================================================================
#endif
