/*=============================================================================
#  Author:          DanteZhu - http://www.vimer.cn
#  Email:           dantezhu@vip.qq.com
#  FileName:        db_openright.cpp
#  Description:     
#  Version:         1.0
#  LastChange:      2010-10-11 12:08:15
#  History:         
=============================================================================*/
#include "db_openright.h"
CDBOpenRight::CDBOpenRight()
{
    m_StrErrMsg[0]='\0';
}

CDBOpenRight::~CDBOpenRight()
{
}

int CDBOpenRight::Init(const char* ip,const char* user,const char* pwd)
{
    m_MySql_Ip = ip;
    m_MySql_User = user;
    m_MySql_Pwd = pwd;

    int ret = m_SqlClient.Connect(m_MySql_Ip.c_str(),m_MySql_User.c_str(),m_MySql_Pwd.c_str(),OPENRIGHT_DB);

    if(ret)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error:[%d][%s]\n",
                __FILE__,__LINE__,__FUNCTION__,ret,m_SqlClient.GetErrMsg());
        return -1;
    }
    return 0;
}

char* CDBOpenRight::GetErrMsg()
{
    return m_StrErrMsg;
}
int CDBOpenRight::GetUinsByApp(unsigned appid,set<unsigned>& setUins)
{
    char strSql[MAX_QUERYLEN_OPENRIGHT];
    snprintf(strSql,sizeof(strSql),"select uin \
            from %s where appid=%u;",OPENRIGHT_TB_CARE,appid);

    int ret;

    ret = m_SqlClient.Execute(strSql);
    if(ret)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error:[%d][%s]\n",
                __FILE__,__LINE__,__FUNCTION__,ret,m_SqlClient.GetErrMsg());
        return -1;
    }

    MYSQL_RES *result = NULL;
    ret = m_SqlClient.Result(result);
    if(ret)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error:[%d][%s]\n",
                __FILE__,__LINE__,__FUNCTION__,ret,m_SqlClient.GetErrMsg());
        return -2;
    }

    StCppResult freeRes(result);

    unsigned int unRecords = mysql_num_rows(result);

    if (0 == unRecords)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error: Result is empty\n",
                __FILE__,__LINE__,__FUNCTION__);
        return 0;
    }
    MYSQL_ROW row;
    for(unsigned int unIndex = 0; unIndex < unRecords; unIndex++)
    {
        row=mysql_fetch_row(result);
        unsigned uin = unsigned(atoi((char*)row[0]));
        setUins.insert(uin);
    }
    return 0;
}

int CDBOpenRight::AddUin2App(unsigned appid,const set<unsigned>& setUins)
{
    if(setUins.size() <= 0)
    {
        return 0;
    }
    if(setUins.size() > 1000)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error:[uins more than 1000]\n",
                __FILE__,__LINE__,__FUNCTION__);
        return -1;
    }
    string strValues;
    char szValue[100];
    for(set<unsigned int>::iterator it = setUins.begin();it!=setUins.end();++it)
    {
        if (setUins.begin() == it)   
        {
            snprintf(szValue,sizeof(szValue),TPL_ADDUIN2APP,*it,appid);
        }
        else
        {
            snprintf(szValue,sizeof(szValue),","TPL_ADDUIN2APP,*it,appid);
        }
        strValues.append(szValue);
    }

    char strSql[MAX_QUERYLEN_OPENRIGHT];
    snprintf(strSql,sizeof(strSql),"insert into %s(uin,appid) VALUES %s;",OPENRIGHT_TB_CARE,strValues.c_str());


    int ret;
    ret = m_SqlClient.Execute(strSql);
    if(ret)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error:[%d][%s]\n",
                __FILE__,__LINE__,__FUNCTION__,ret,m_SqlClient.GetErrMsg());
        return -2;
    }
    if(m_SqlClient.AffectRows()<=0)
    {
        snprintf(m_StrErrMsg,sizeof(m_StrErrMsg),"[%s][%d][%s]Error:[%d][%s]\n",
                __FILE__,__LINE__,__FUNCTION__,ret,m_SqlClient.GetErrMsg());
        return -3;
    }
    return 0;
}
